package org.netkernel.doc.endpoint;

import org.netkernel.layer0.nkf.INKFRequestContext;
import org.netkernel.module.standard.endpoint.StandardAccessorImpl;


/**
 * This engine will return the enclosed text as literal HTML.
 * This will allow the specification of HTML forms, etc.
 * in the documentation.
 */


public class HTMLEngine extends StandardAccessorImpl
  {
  public HTMLEngine()
    {
    this.declareThreadSafe();
    }


  @Override
  public void onSource(INKFRequestContext aContext) throws Exception
    {
    String type = aContext.getThisRequest().getArgumentValue("activeType");
    String operandValue = aContext.source("arg:operand", String.class);
    if (type.endsWith("XHTML"))
      {
      // XHTML
      aContext.createResponseFrom(operandValue);
      }
    else
      {  //Docbook
      aContext.createResponseFrom("<note><![CDATA[" + operandValue + "]]></note>");
      }
    }

  }
