package org.netkernel.doc.endpoint;

import org.netkernel.layer0.nkf.INKFRequest;
import org.netkernel.layer0.nkf.INKFRequestContext;
import org.netkernel.layer0.representation.IHDSNode;
import org.netkernel.layer0.urii.SimpleIdentifierImpl;
import org.netkernel.module.standard.endpoint.TransparentOverlayImpl;
import org.netkernel.request.IRequestScopeLevel;
import org.netkernel.request.impl.RequestScopeLevelImpl;
import org.netkernel.urii.INetKernelException;
import org.netkernel.urii.ISpace;
import org.netkernel.urii.impl.Version;

public class RelativeContextOverlay extends TransparentOverlayImpl
{
	
	public RelativeContextOverlay()
	{	declareThreadSafe();
		declareUnhandledExceptionsExpired(false);
	}	
	
	private ISpace findSpace(INKFRequestContext context) throws INetKernelException
	{
		IHDSNode docEntry=context.source("arg:docentry", IHDSNode.class);
		String space=(String)docEntry.getFirstValue("doc/space");
		String version=(String)docEntry.getFirstValue("doc/version");
		Version v=new Version(version);
		return getKernel().getSpace(new SimpleIdentifierImpl(space), v, v);
	}
	
	public void onRequest(String aID, INKFRequestContext context) throws Exception
	{	ISpace relativeContextSpace=findSpace(context);
		ISpace delegateSpace=this.getDelegateSpace();
		IRequestScopeLevel scope=RequestScopeLevelImpl.createScopeLevel(relativeContextSpace, context.getKernelContext().getRequestScope(), false);
		scope=RequestScopeLevelImpl.createScopeLevel(delegateSpace, scope, false);
		
		INKFRequest req=context.getThisRequest().getIssuableClone();
		req.setRequestScope(scope);
		context.createResponseFrom(context.issueRequestForResponse(req));
	}

}